<?php
namespace BK\Record;

use BK\PDO\SQLite;
use BK\Record;

class Search extends Record {
    public $table = 'customers';
    function __construct(SQLite $db, $id = null) {
        parent::__construct($db, $id);
    }

    public function _global($string) {
        $string = "%{$string}%";
        $values = [];
        // UNION ALL
        $sql = "
            SELECT c.id, c.name, c.phone AS description1, c.email AS description2, c.type AS type
            FROM entity AS c
            WHERE c.name LIKE ? OR c.phone LIKE ? OR c.email LIKE ?
            UNION ALL
            SELECT v.id, v.name, v.make_model AS description1, v.year AS description2, 'vehicle' as type
            FROM vehicle AS v
            WHERE v.name LIKE ?
            UNION ALL
            SELECT w.id, 'WO' || w.id AS name, we.name AS description1, wv.name AS description2, 'workorder' as type
            FROM workorder AS w
                LEFT JOIN vehicle AS wv ON w.vehicle_id = wv.id
                LEFT JOIN entity AS we ON w.entity_id = we.id 
            WHERE w.authorized_name LIKE ? OR w.authorized_phone LIKE ? OR w.notes LIKE ? OR we.name LIKE ? OR wv.name LIKE ?
            ";
        for ($index = 0; $index < substr_count($sql,"?"); $index++) {
            $values[] = $string;
        }
//        echo "<pre>";
//        print_r($sql);
//        print_r($values); die();
        return $this->db->prepare($sql)
            ->execute($values)->fetchAll();
    }



}